*! version 2.0.1 02jan2004
program merge
	version 8.2

	gettoken first 0: 0

	while (`"`first'"' != "using" & `"`first'"' != "") {
		local vlist "`vlist' `first'"
		gettoken first 0: 0
	}

	if "`vlist'" != "" {
		unab vlist : `vlist'
		foreach var of local vlist {
			capture confirm variable `var'
			if _rc {
				di as err "variable `var' not found"
				exit 111
			}
		}
	}

	if (`"`first'"' != "using") {
		di as err "using required"
		exit 100
	}
	else {
		syntax [anything] [, _merge(string) noSummary *]
	}

	if ("`_merge'" != "") {
		capture confirm new variable `_merge'
		if _rc {
			di as err `"`_merge' invalid name"'
			exit 198
		}
		local _mergeoption "_merge(`_merge')"
	}
	else {
		local _mergeoption "_merge(_merge)"
		local _merge "_merge"
	}

	local wordct : word count `anything'
	if (`wordct' == 1) {
		if ("`summary'" != "") {
		  di as txt "note: nosummary ignored when only one using file is specified"
		}
		_merge `vlist' using `anything', `_mergeoption' `options'
	}
	else {
		if (index("`options'","update") > 0) {
			di as err ///
				"update not allowed with multiple using files"
			exit 198
		}

		tempvar merge
		gen `merge' = 0

		local i 1
		foreach file in `anything' {
			if `"`vlist'"' != "" & `i' > 1 {
				sort `vlist'
			}
			_merge `vlist' using "`file'", `_mergeoption' `options'
			qui replace `merge' = `_merge' ///
				if `_merge' > `merge' | `merge' >= .
			if ("`summary'" == "") {
				rename `_merge' `_merge'`i'
				label variable `_merge'`i' ///
					`"_merge representing `file'"'
			}
			else {
				drop `_merge'
			}
			local ++i
		}

		gen byte `_merge' = `merge'
		drop `merge'

		if ("`summary'" == "") {
			qui recode `_merge'?* (1 .=0) (2/5=1)
		}
	}
end

